
(* PL0LEX.PAS: created 5-27-1992 at  2:14 pm
   by Lex Version 2.0, Copyright (c) 1989 Albert Graef, all rights reserved *)

(*
 * pl0lex.l
 *
 * lex input file for PL/0 scanner
 *
 *   adapted to Turbo Pascal Lex  HW
 *   Note: keywords are determined by scanning a keyword table, rather
 *   than including the keyword patterns in the Lex source which is done
 *   in the original version of this file. The main reason for this is,
 *   that the DFA table generated from the original spec grows too large
 *   to be compilable by Turbo Pascal (Lex will construct the table,
 *   but Turbo Pascal puts it into the static data segment which holds
 *   all typed constants and global variables, and this data segment is
 *   64 KB max.).
 *)

UNIT PL0Lex;

INTERFACE

USES PL0INIT, LexLib, YaccLib;

{$I PL0.H}

VAR
  line_no : integer;

function yylex : integer;
function act_token : string;

IMPLEMENTATION

const newline = #10;

procedure commenteof;
  begin
    writeln('unexpected EOF inside comment at line ', line_no);
  end(*commenteof*);

function is_keyword(id : string; var token : integer) : boolean; 
  (* checks whether id is PL0 keyword; if so, returns corresponding
     token number in token *)
  forward;


const yylnl=#10;
const yylbufsize = 255;
const yylsstate0 : System.integer = 0;
var yylsstate : System.integer absolute yylsstate0;
const yylastate0 : System.integer = 0;
var yylastate : System.integer absolute yylastate0;
var yylreturn : System.boolean; yyltok : System.integer;
var yytext : string[yylbufsize];
var yyleng : Byte absolute yytext;
var yyleng0 : Byte;
procedure begin_(s : System.integer);
  begin yylsstate := s end;
procedure return(tok : System.integer);
  begin yylreturn := true; yyltok := tok end;
procedure yymore;
  begin yyleng0 := yyleng end;
procedure yyless(n : System.integer);
  begin
    while yyleng>n do begin unput(yytext[yyleng]); dec(yyleng) end
  end;
procedure echo;
  var i : System.integer;
  begin
    for i := 1 to yyleng do output(yytext[i])
  end;
procedure reject; forward;
procedure yylaction(yylrule : System.integer);
 var
   c  : char;
   kw : integer;
   cd : integer;

begin case yylrule of
0: ;
1:if is_keyword(yytext, kw) then                          return(kw)
                        else
                        begin
                          yylval.ident:= yytext;
                          return(IDENTIFIER);
                        end;

2:begin                          yylval.ident:=
                             copy(yytext, 2, length(yytext)-2);
                          return(_STRING);
                        end;

3:return(ASSIGNMENT);
4:return(COLON);
5:return(COMMA);
6:begin                           val(yytext, yylval.number, cd);
                           return(NUMBER);
                        end;

7:return(DOT);
8:return(EQUAL);
9:return(GREATERE);
10:return(GREATER);
11:return(LESSE);
12:return(LPAREN);
13:return(LESS);
14:return(MINUS);
15:return(NOTEQUAL);
16:return(PLUS);
17:return(RPAREN);
18:return(SEMICOLON);
19:return(SLASH);
20:return(STAR);
21:return(LBRACKET);
22:return(RBRACKET);
23:begin                          repeat
			    c := input;
			    case c of
			      '*' : begin
				      c := input;
				      if c=')' then exit else unput(c)
				    end;
			      newline : inc(line_no);
                              #0 : commenteof;
			    end;
			  until false
                        end;

24:;
25:inc(line_no);
26:writeln('''', yytext[1], ''' (#', ord(yytext[1]),			  '): illegal character at line ', line_no);

end(*case*);
end(*yylaction*);

const yylrules = 26;
const yylstates = 32;
const yyltrans = 471;
const yylmatch_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,2,4,5,7,8,10,12,14,
  16,18,20,22,24,26,28,30,32,34,
  36,38,40,42,45,45,46,47,48,49,
  50,51,52);
const yylmatch_entries = 51;
const yylmatch : array [0..yylmatch_entries] of System.integer = (0,
  26,24,26,25,15,26,26,12,26,17,
  26,20,26,16,26,5,26,14,26,7,
  26,19,26,6,26,4,26,18,26,13,
  26,8,26,10,26,1,26,21,26,22,
  26,1,24,26,2,23,6,3,11,9,
  1);
const yylendpos_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,2,4,5,7,8,10,12,14,
  16,18,20,22,24,26,28,30,32,34,
  36,38,40,42,45,45,46,47,48,49,
  50,51,52);
const yylendpos_entries = 51;
const yylendpos : array [0..yylendpos_entries] of System.integer = (0,
  26,24,26,25,15,26,26,12,26,17,
  26,20,26,16,26,5,26,14,26,7,
  26,19,26,6,26,4,26,18,26,13,
  26,8,26,10,26,1,26,21,26,22,
  26,1,24,26,2,23,6,3,11,9,
  1);
const yylstop : array [0..yylstates] of System.boolean = (
  FALSE,FALSE,TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,TRUE,TRUE,
  TRUE,TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,TRUE,FALSE,TRUE,
  FALSE,FALSE,TRUE,TRUE,FALSE,FALSE,TRUE,TRUE,FALSE,TRUE,
  TRUE,TRUE,FALSE);
const yylbase : array [0..yylstates] of System.integer = (
  1,124,-255,-255,-255,-255,25,-40,-255,-255,
  -255,-255,-255,-255,-255,-36,-58,-255,-57,-255,
  -56,199,-255,-255,274,26,-255,-255,87,-255,
  -255,-255,349);
const yyldefault : array [0..yylstates] of System.integer = (
  2,2,-1,-1,-1,-1,25,-1,-1,-1,
  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,25,-1,-1,-1,-1,
  -1,-1,-1);
{$define yyltrans}
const yylnext : array [1..yyltrans] of System.integer = (
  -1,27,29,30,31,-1,-1,-1,-1,3,
  4,28,28,28,28,28,28,28,28,28,
  28,-1,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,3,-1,-1,5,-1,-1,-1,6,
  7,8,9,10,11,12,13,14,15,15,
  15,15,15,15,15,15,15,15,16,17,
  18,19,20,26,26,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,22,-1,23,-1,-1,-1,21,21,21,
  21,21,24,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,3,4,28,28,28,28,28,28,
  28,28,28,28,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,3,-1,-1,5,-1,
  -1,-1,6,7,8,9,10,11,12,13,
  14,15,15,15,15,15,15,15,15,15,
  15,16,17,18,19,20,-1,-1,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,22,-1,23,-1,-1,-1,
  21,21,21,21,21,24,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,21,21,32,32,32,32,
  32,32,32,32,32,32,-1,-1,-1,-1,
  -1,-1,-1,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,-1,
  -1,-1,-1,-1,-1,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,-1,-1,-1,-1,-1,-1,-1,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,-1,-1,-1,-1,-1,-1,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,-1,-1,-1,-1,
  -1,-1,-1,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,-1,
  -1,-1,-1,-1,-1,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32);
const yylcheck : array [1..yyltrans] of System.integer = (
  0,7,16,18,20,-1,-1,-1,-1,0,
  0,15,15,15,15,15,15,15,15,15,
  15,-1,-1,-1,6,25,-1,-1,-1,-1,
  -1,-1,0,-1,-1,0,-1,-1,-1,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,6,25,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,-1,0,-1,-1,-1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,-1,-1,-1,-1,-1,-1,
  -1,-1,1,1,28,28,28,28,28,28,
  28,28,28,28,-1,-1,-1,-1,-1,-1,
  -1,-1,-1,-1,-1,1,-1,-1,1,-1,
  -1,-1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,-1,-1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,-1,1,-1,-1,-1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,21,21,21,21,
  21,21,21,21,21,21,-1,-1,-1,-1,
  -1,-1,-1,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,-1,
  -1,-1,-1,-1,-1,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,21,21,21,21,21,21,21,21,21,
  21,24,24,24,24,24,24,24,24,24,
  24,-1,-1,-1,-1,-1,-1,-1,24,24,
  24,24,24,24,24,24,24,24,24,24,
  24,24,24,24,24,24,24,24,24,24,
  24,24,24,24,-1,-1,-1,-1,-1,-1,
  24,24,24,24,24,24,24,24,24,24,
  24,24,24,24,24,24,24,24,24,24,
  24,24,24,24,24,24,32,32,32,32,
  32,32,32,32,32,32,-1,-1,-1,-1,
  -1,-1,-1,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,-1,
  -1,-1,-1,-1,-1,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32,32,32,32,32,32,32,32,32,32,
  32);


var yylstate, yylrule, yylrule0, yylpos, yylpos0 : System.integer;
var yylends, yylmatches : array [0..yylrules] of System.integer;
procedure reject;
  var r : System.integer;
  begin
    yylrule0 := 0; yylpos0 := yylpos; yyleng0 := yyleng;
    for r := 1 to yylrules do
      if ((yylmatches[r]=yylmatches[yylrule]) and (r>yylrule) or
          (yylmatches[r]<yylmatches[yylrule])) and
         (yylmatches[r]>yylmatches[yylrule0]) then
        yylrule0 := r;
    if yylpos0<yylmatches[yylrule0] then
      while yylpos0<yylmatches[yylrule0] do
        begin
          inc(yyleng0); yytext[yyleng0] := input; inc(yylpos0)
        end
    else
      while yylpos0>yylmatches[yylrule0] do
        begin
          unput(yytext[yyleng0]); dec(yyleng0); dec(yylpos0)
        end
  end(*reject*);
function yylterm : System.boolean;
  var i, s1, isc : System.integer; c : System.char;
  begin
    inc(yylpos);
    if succ(yyleng)=yylbufsize then if yyloverflow then halt(1);
    if yylmatch_base[pred(yylstate)]<yylmatch_base[yylstate] then
      begin
        yylrule := yylmatch[yylmatch_base[pred(yylstate)]];
        for i := yylmatch_base[pred(yylstate)] to pred(yylmatch_base[yylstate]) do
          yylmatches[yylmatch[i]] := yylpos
      end;
    if yylendpos_base[pred(yylstate)]<yylendpos_base[yylstate] then
      begin
        for i := yylendpos_base[pred(yylstate)] to pred(yylendpos_base[yylstate]) do
          yylends[yylendpos[i]] := yylpos
      end;
    if (yyleng=yylbufsize) or yylstop[yylstate] then begin yylterm := System.true; exit end;
    c := input;
    {$ifdef yyltrans}
    isc := yylbase[yylstate]+System.ord(c);
    if (isc<1) or (isc>yyltrans) or (yylcheck[isc]<>yylstate) then
      s1 := yyldefault[yylstate]
    else
      s1 := yylnext[isc];
    {$else}
      s1 := yyldefault[yylstate]
    {$endif}
    if s1=-1 then
      begin
        yylterm := System.true;
        unput(c)
      end
    else
      begin
        yylterm := System.false;
        inc(yyleng); yytext[yyleng] := c;
        yylstate := s1
      end
  end(*yylterm*);
procedure yylback;
  var c : System.char;
  begin
    while yylpos>yylends[yylrule] do
      begin dec(yylpos); unput(yytext[yyleng]); dec(yyleng) end;
    if yylpos=1 then
      begin
        (* take default action *)
        yylpos0 := 0; yylrule0 := 0; c := input;
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1;
        if c<>#0 then output(c)
        else if yywrap then begin yylsstate := 0; return(0) end
      end
    else
      begin
        c := yytext[yyleng];
        yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
        yylaction(yylrule);
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1
      end
  end(*yylback*);
function yylex : System.integer;
  begin
    yylmatches[0] := 1; yylends[0] := 1;
    yylreturn := System.false;
    yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
    repeat
      yyleng := yyleng0; yylpos := yylpos0; yylrule := yylrule0;
      if yylpos=0 then
        begin
          (* initialize match table, end position table, and DFA state: *)
          fillChar(yylmatches[1],52,#0);
          fillChar(yylends[1],52,#0);
          yylstate := yylsstate+yylastate;
          while not yylterm do ;
        end;
      yylback;
    until yylreturn;
    yylex := yyltok
  end(*yylex*);



function upper(id : string) : string;
  var i : integer;
  begin
    for i := 1 to length(id) do
      id[i] := upCase(id[i]);
    upper := id
  end(*upper*);

function is_keyword(id : string; var token : integer) : boolean;
  const
    id_len = 20;
  type
    Ident = string[id_len];
  const
    (* table of PL0 keywords: *)
    no_of_keywords = 22;
    keyword : array [1..no_of_keywords] of Ident =
      (
      'BEGIN',
      'CALL',
      'CASE',
      'CONST',
      'DO',
      'DOWNTO',
      'ELSE',
      'END',
      'FOR',
      'IF',
      'ODD',
      'OF',
      'PROCEDURE',
      'READ',
      'REPEAT',
      'THEN',
      'TO',
      'UNTIL',
      'VAR',
      'WHILE',
      'WRITE',
      'WRITELN'
      );
    keyword_token : array [1..no_of_keywords] of integer =
      (
      _BEGIN,
      CALL,
      _CASE,
      _CONST,
      _DO,
      _DOWNTO,
      _ELSE,
      _END,
      _FOR,
      _IF,
      ODD,
      _OF,
      _PROCEDURE,
      _READ,
      _REPEAT,
      _THEN,
      _TO,
      _UNTIL,
      _VAR,
      _WHILE,
      _WRITE,
      _WRITELN
      );

  var m, n, k : integer;
  begin
    id := upper(id);
    m := 1; n := no_of_keywords;
    while m<=n do
      begin
        k := m+(n-m) div 2;
        if id=keyword[k] then
          begin
            is_keyword := true;
            token := keyword_token[k];
            exit
          end
        else if id>keyword[k] then
          m := k+1
        else
          n := k-1
      end;
    is_keyword := false
  end(*is_keyword*);

function act_token : string;
  begin
    act_token := yytext
  end(*act_token*);

begin
  if paramcount = 0 then
  begin
    write('Input file [.PL0]: ');
    readln(sourcefile);
  end
  else
    sourcefile:= paramstr(1);
  if pos('.', sourcefile) = 0 then
     sourcefile:= sourcefile + '.pl0';
  line_no := 1;
  assign(yyin, sourcefile);
  (*$I-*) reset(yyin); (*$I+*)
  IF IOResult <> 0 THEN
  BEGIN
     WriteLn('File ', sourcefile, ' not found.');
     HALT(1)
  END;
end.
