  {-------------------------------------------------------------------}
  { WC.L  :  Beispiel fr ein Lex-Programm fr die LEX-PASCAL-Version }
  { Es wird ein PASCAL-Programm generiert, mit dem die Zeilen Worte   }
  { und Zeichen in einem Text gezhlt werden knnen                   }
  { nach:                                                             }
  { H.Herold:                                                         }
  { lex und yacc - lexikalische und syntaktische Analyse              }
  { Addison & Wesley 1992                                             }
  {-------------------------------------------------------------------}


  { Deklarationen mindestens 1 Zeichen einrcken !                    }
  { LEXLIB.PAS ist in (fast) jedem Fall erforderlich                  }

  USES Crt, LexLib;

  CONST line_counter: Integer=0;
        ipkt_counter: Integer=0;
        leer_counter: Integer=0;
        char_counter: Integer=0;

%%

\n    BEGIN { Zeilenwechsel }
        inc(line_counter);
        inc(ipkt_counter);
        inc(char_counter);
      END;

" "   BEGIN { Leerzeichen }
        inc(leer_counter);
        inc(char_counter);
      END;

\t    BEGIN { Tabulatorzeichen }
        inc(leer_counter);
        inc(char_counter);
      END;

\.    BEGIN  { Punkt }
        inc(ipkt_counter);
        inc(char_counter);
      END;

!     BEGIN  { Ausrufezeichen }
        inc(ipkt_counter);
        inc(char_counter);
      END;

;     BEGIN  { Strichpunkt }
        inc(ipkt_counter);
        inc(char_counter);
      END;

\,    BEGIN  { Komma }
        inc(ipkt_counter);
        inc(char_counter);
      END;

\?    BEGIN  { Fragezeichen }
        inc(ipkt_counter);
        inc(char_counter);
      END;

:     BEGIN  { Doppelpunkt }
        inc(ipkt_counter);
        inc(char_counter);
      END;

.     inc(char_counter);  { andere Einzelzeichen }

%%

BEGIN
  if yylex=0 then (* done *)
    BEGIN
      ClrScr;
      WriteLn ('Gesamtzahl der Zeichen :       ', char_counter);
      WriteLn ('Anzahl der Satzzeichen :       ', ipkt_counter);
      WriteLn ('Anzahl der Leerzeichen :       ', leer_counter);
      WriteLn ('Anzahl der Zeilen      :       ', line_counter);
    END
END.
